%{
#include <stdlib.h>
#include <string.h>

#include "ts34131.tab.c"

extern int input();
extern void yyunput();
extern FILE *output;

void outputinline(void)
{
    int c;

	for(;;)
	{
		while((c = input())!='%')
			fputc(c, output);
		if(input()=='}')
			return;
		else
			yyunput(yytext[yyleng-1]);
	}
}

void skipcomments(void)
{
	for(;;)
	{
		while(input()!='*')
			;
		if(input()=='/')
			return;
		else
			yyunput(yytext[yyleng-1]);
	}
}
%}

%%
[ \t\n]                 ;

"."                     { 
                          return yylval.token = PERIOD;
                        }

","                     { 
                          return yylval.token = COMMA;
                        }

"IF"                    { 
                          return yylval.token = IF;
                        }

"THEN"                  { 
                          return yylval.token = THEN;
                        }


"AND"                   { 
                          return yylval.token = AND;

                        }

"OR"                    { 
                          return yylval.token = OR;
                        }

"SET"                   { 
                          return yylval.token = SET;

                        }

"TO"                    { 
                          return yylval.token = TO;
                        }

"{"[^}]*"}"             { strcpy(yylval.expression, &yytext[1]);
                          yylval.expression[strlen(yylval.expression)-1] = '\0';
                          return EXPRESSION;
                        }

'[ABCDEFabcdef0-9]+'    { yylval.number = strtol(&yytext[1], 0, 16); 
                          return NUMBER; 
                        }

[A-Za-z0-9]+            { strcpy(yylval.name, yytext); 
                          return NAME; 
                        }

"/*"	                skipcomments();

"%{"	                outputinline();

%%

